#ifndef H_SqlParser
#define H_SqlParser

#include "parser.h"

class SqlParser : public Parser {
	public :
		char		*sql_database;
		
		Text		*sql_results;
		
		int		sql_row_type;	/* 0 = Backup no Rows
						   1 = Rows in file
						   2 = Rows in Text
						*/
		
		Text		*sql_row_text;
		int		sql_row_fd;
		LineStream	*sql_row_stream;
		
		SqlParser();
		virtual ~SqlParser( );
		
		virtual int	message(char *str,
			char *s1=0, char *s2=0, char *s3=0,
			char *s4=0, char *s5=0, char *s6=0,
			char *s7=0, char *s8=0, char *s9=0
			);
		virtual int	error(
			char *s1=0, char *s2=0, char *s3=0,
			char *s4=0, char *s5=0, char *s6=0,
			char *s7=0, char *s8=0, char *s9=0
			);
		
		virtual int		sql();
		virtual int		statement();
		virtual int		database();
		
		virtual int		sql_new(LineStream *Init);
		virtual int		sql_new(Text *Init);
		virtual int		sql_new(char *Init);
		
		virtual int		sql_open();
		virtual int		sql_close();
		
		virtual int		sql_up();
		
		virtual void		sql_purge();
		virtual void		sql_read();
		
		virtual Text		*sql_getresult();
		virtual LineStream	*sql_getstream();
		virtual char		*sql_getrow();
		virtual int		sql_getnum();
	};

#endif
